IMPLEMENTATION MODULE RETARDO;

    IMPORT Lib;

(* ------------------------------------------------------------------- *)
PROCEDURE CalcularTiempo (retardo : CARDINAL) : LONGCARD;

 VAR
    h1, m1, s1, hs1 : CARDINAL;  (* hora inicial *)
    h2, m2, s2, hs2 : CARDINAL;  (* hora final   *)
    transcurrido    : LONGCARD;  (* hora final - hora inicial *)

 BEGIN

    (* calculamos el retardo rectificado con CARDINAL *)
    Lib.GetTime (h1, m1, s1, hs1);    (* DEspreciamos el tiempo que tarda el PROC *)
    Lib.Delay   (retardo);
    Lib.GetTime (h2, m2, s2, hs2);

    (* Solo funciona si la hora inicial es menor que la final *)
    transcurrido := (
                       ( LONGCARD(h2)*60*60*100 + LONGCARD(m2)*60*100 + LONGCARD(s2)*100 +LONGCARD(hs2) )
                                 - (* restamos a lo bruto *)
                       (LONGCARD(h1)*60*60*100 + LONGCARD(m1)*60*100 + LONGCARD(s1)*100 +LONGCARD(hs1) )
                    );


      RETURN (transcurrido*10) (* *10 ya que lo damos en milisegundos *)

END CalcularTiempo;
(* ------------------------------------------------------------------- *)
PROCEDURE conReales (     transcurrido : LONGCARD;
                          retardo      : CARDINAL;
                      VAR salida       : CARDINAL);
    VAR
      t_trans   : REAL;
      t_retardo : REAL;
      temp      : REAL;
      temp2, temp3 : CARDINAL;

    BEGIN

      t_trans   := REAL (transcurrido);
      t_retardo := REAL (retardo);

      temp      := (t_retardo * t_retardo) / t_trans;
                   (* Usamos todos los decimales *)

      (* efectuamos redondeo solo para valores altos, > .75 *)

(*     Redondeamos de manera cutre *)

       temp2 := TRUNC (temp + 0.25);   (* TRUNC redondea por defecto   *)
       temp3 := TRUNC (temp);          (* as que si es mayor al sumar *)
                                       (* 0.25 es que era xxx.75xxxx   *)
       IF temp2 > temp3 THEN
           temp := temp + 0.25;
       END;

       salida := TRUNC (temp);

END conReales;
(* ------------------------------------------------------------------- *)
PROCEDURE conLongCard (    transcurrido : LONGCARD;
                           retardo      : CARDINAL;
                       VAR salida       : CARDINAL);
   VAR
     temp : LONGCARD;
   BEGIN
        (* es una regla de 3 *)
        (* temp =  (retardo*retardo) DIV transcurrido  *)
        IF transcurrido > 0 THEN
           temp    :=  LONGCARD(retardo);
           temp    := (temp*temp) DIV transcurrido;
           salida  := CARDINAL(temp)
        ELSE
           salida := CARDINAL(retardo);
           (* no hacemo snada *)
        END;
END conLongCard;
(* ------------------------------------------------------------------- *)
PROCEDURE Ajustar ( retardo : CARDINAL): CARDINAL;  (* tiempo que queremos que pase     *)

 VAR
     t_real          : LONGCARD;   (* tiempo que ha pasado en realidad *)
     rectificadoCARD : CARDINAL;
     rectificadoREAL : CARDINAL;

 BEGIN

     t_real         := CalcularTiempo (retardo);

    conLongCard    (t_real, retardo, rectificadoCARD);
    RETURN (rectificadoCARD);

    (* conReales      (t_real, retardo, rectificadoREAL); *)
    (* RETURN (rectificadoREAL) *)

END Ajustar;
(* ------------------------------------------------------------------- *)
PROCEDURE Delay (ms : CARDINAL);
  BEGIN
     (*llamamos a lib.delay*)
     Lib.Delay (ms);
END Delay;
(* ------------------------------------------------------------------- *)


END RETARDO.
